You are given a 0-indexed integer array nums
and an integer p
. Find p
pairs of indices of nums
such that the maximum difference amongst all the pairs is minimized. Also, ensure no index appears more than once amongst the p
pairs.
Note that for a pair of elements at the index i
and j
, the difference of this pair is |nums[i] - nums[j]|
, where |x|
represents the absolute value of x
.
Return the minimum maximum difference among all p
pairs. We define the maximum of an empty set to be zero.
Example 1:
Input: nums = [10,1,2,7,1,3], p = 2 Output: 1 Explanation: The first pair is formed from the indices 1 and 4, and the second pair is formed from the indices 2 and 5. The maximum difference is max(|nums[1] - nums[4]|, |nums[2] - nums[5]|) = max(0, 1) = 1. Therefore, we return 1.
Example 2:
Input: nums = [4,2,1,2], p = 1 Output: 0 Explanation: Let the indices 1 and 3 form a pair. The difference of that pair is |2 - 2| = 0, which is the minimum we can attain.
Constraints:
1 <= nums.length <= 105
0 <= nums[i] <= 109
0 <= p <= (nums.length)/2
Companies: Amazon, Apple, Microsoft
Related Topics:
Array, Binary Search, Greedy
Similar Questions:
- Minimum Absolute Difference (Easy)
- Minimum Difference Between Largest and Smallest Value in Three Moves (Medium)
// OJ: https://leetcode.com/problems/minimize-the-maximum-difference-of-pairs
// Author: github.com/lzl124631x
// Time: O(NlogN)
// Space: O(1)
class Solution {
public:
int minimizeMax(vector<int>& A, int P) {
sort(begin(A), end(A));
int N = A.size(), L = 0, R = A.back() - A[0];
auto valid = [&](int t) {
int cnt = 0;
for (int i = 1; i < N && cnt < P;) {
if (A[i] - A[i - 1] <= t) ++cnt, i += 2;
else ++i;
}
return cnt == P;
};
while (L <= R) {
int M = (L + R) / 2;
if (valid(M)) R = M - 1;
else L = M + 1;
}
return L;
}
};